# bans users who join a channel and the first thing they say is spammy, unless
# they idle for a few seconds before saying it, or unless they're +f.
# If the DroneBL TCL library is loaded, submit offenders as type 3 (IRC bot).
# You must load dronebl.tcl before this script for DroneBL functionality.

namespace eval banjoinurl {

set kickreason "*punt*"
set grumble "fucking spam bots...."

set spamwords {
	"http:"
	"https:"
	"www."
	"free"
	"hack"
	"porn"
}

set exemptwords {
	"mibbit"
	"dronebl"
	"google"
}

# bantime in minutes.  2880 = 2 days
set spambantime 2880

bind join - * [namespace current]::bju_join

if {[catch {set dronebl ::dronebl::key} 0]} {
	set dronebl 0
} else {
	set dronebl 1
}


proc bju_join {nick uhost handle chan} {
	if {[botisop $chan] && ![matchattr $handle f|f $chan]} {
		regsub -all {\W} $uhost "" who
		set bju_chan($who) $chan
		bind pubm - "$chan $uhost" [namespace current]::bju_pubm
		bind ctcp - ACTION [namespace current]::bju_ctcp
		bind ctcr - ACTION [namespace current]::bju_ctcp
		bind notc - $uhost [namespace current]::bju_notice
		bind msgm - $uhost [namespace current]::bju_privmsg
		utimer 15 "[namespace current]::bju_cleanup $chan $uhost"
	}
}

proc bju_pubm {nick uhost handle chan txt} {
	global botnick
	regsub -all {\W} $uhost "" who
	if {[info exists bju_chan($who)] && ($chan == $bju_chan($who))} {
		foreach goodword $exemptwords {
			if {[regexp -nocase "$goodword" $txt]} {
				set exempt 1
				break
			}
		}
		if {![info exists exempt]} {
			foreach badword $spamwords {
				if {[regexp -nocase $badword $txt]} {
					set banhost [lindex [split $bju_uhost @] 1]
					newban "*!*@$banhost" $botnick "spambot" $spambantime
					if {[botisop $chan]} {
						putquick "MODE $chan +b *!*@$banhost"
						putquick "KICK $chan $nick :$kickreason"
						putlog "banjoinurl: Banning $nick from $chan"
						putserv "PRIVMSG $chan :$grumble"
					}
					if {$dronebl} { ::dronebl::submit "3 $banhost" }
					break
				}
			}
		}
		bju_cleanup $chan $uhost
	}
}

proc bju_ctcp {nick uhost handle chan keyword txt} {
	bju_pubm $nick $uhost $handle $chan $txt
}

proc bju_notice {nick uhost hand text {dest ""}} {
	global botnick; if {$dest == ""} {set dest $botnick}
	regsub -all {\W} $uhost "" who
	bju_pubm $nick $uhost $hand $bju_chan($who) $text
}

proc bju_privmsg {nick uhost hand text} {
	regsub -all {\W} $uhost "" who
	bju_pubm $nick $uhost $hand $bju_chan($who) $text
}

proc bju_cleanup {chan uhost} {
	regsub -all {\W} $uhost "" who
	unbind pubm - "$chan $uhost" [namespace current]::bju_pubm
	unbind ctcp - ACTION [namespace current]::bju_ctcp
	unbind ctcr - ACTION [namespace current]::bju_ctcp
	unbind notc - $uhost [namespace current]::bju_notice
	unbind msgm - $uhost [namespace current]::bju_privmsg
	catch {unset bju_chan($who)} 0
}

if {$dronebl} {
	putlog "banjoinurl.tcl loaded with DroneBL support.  Heh."
} else {
	putlog "banjoinurl.tcl loaded.  Heh."
}

}; # end namespace declaration
